import{s as Oe,n as Ve,o as Ae}from"../chunks/scheduler.85c25b89.js";import{S as je,i as Ue,g as i,s as n,r as c,A as qe,h as m,f as a,c as r,j as f,u as d,x,k as g,y as s,a as l,v as p,d as u,t as v,w as h}from"../chunks/index.c9837788.js";import{D as L}from"../chunks/Docstring.5c1d567f.js";import{H as ge,E as Ge}from"../chunks/EditOnGithub.b65eee75.js";function Be(Se){let $,Z,X,ee,T,ae,S,ze="This page contains the API reference documentation for learning rate schedulers included in <code>timm</code>.",te,z,le,R,ne,C,P,re,M,H,ie,E,me,o,k,$e,U,Re=`Cosine decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1608.03983" rel="nofollow">https://arxiv.org/abs/1608.03983</a>.`,be,q,Ce=`Inspiration from
<a href="https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py" rel="nofollow">https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py</a>`,ye,G,Pe='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',se,D,I,oe,b,N,we,B,Me="Decay the LR by a factor every time the validation loss plateaus.",ce,_,F,xe,J,He="Polynomial LR Scheduler w/ warmup, noise, and k-decay",Le,K,Ee='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',de,O,V,pe,y,A,Te,Q,ke=`Hyberbolic-Tangent decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1806.01593" rel="nofollow">https://arxiv.org/abs/1806.01593</a>`,ue,j,ve,Y,he;return T=new ge({props:{title:"Learning Rate Schedulers",local:"learning-rate-schedulers",headingTag:"h1"}}),z=new ge({props:{title:"Schedulers",local:"schedulers",headingTag:"h2"}}),R=new ge({props:{title:"Factory functions",local:"timm.scheduler.create_scheduler",headingTag:"h3"}}),P=new L({props:{name:"timm.scheduler.create_scheduler",anchor:"timm.scheduler.create_scheduler",parameters:[{name:"args",val:""},{name:"optimizer",val:": Optimizer"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/scheduler_factory.py#L51"}}),H=new L({props:{name:"timm.scheduler.create_scheduler_v2",anchor:"timm.scheduler.create_scheduler_v2",parameters:[{name:"optimizer",val:": Optimizer"},{name:"sched",val:": str = 'cosine'"},{name:"num_epochs",val:": int = 300"},{name:"decay_epochs",val:": int = 90"},{name:"decay_milestones",val:": typing.List[int] = (90, 180, 270)"},{name:"cooldown_epochs",val:": int = 0"},{name:"patience_epochs",val:": int = 10"},{name:"decay_rate",val:": float = 0.1"},{name:"min_lr",val:": float = 0"},{name:"warmup_lr",val:": float = 1e-05"},{name:"warmup_epochs",val:": int = 0"},{name:"warmup_prefix",val:": bool = False"},{name:"noise",val:": typing.Union[float, typing.List[float]] = None"},{name:"noise_pct",val:": float = 0.67"},{name:"noise_std",val:": float = 1.0"},{name:"noise_seed",val:": int = 42"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 0.1"},{name:"cycle_limit",val:": int = 1"},{name:"k_decay",val:": float = 1.0"},{name:"plateau_mode",val:": str = 'max'"},{name:"step_on_epochs",val:": bool = True"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/scheduler_factory.py#L63"}}),E=new ge({props:{title:"Scheduler Classes",local:"timm.scheduler.CosineLRScheduler",headingTag:"h3"}}),k=new L({props:{name:"class timm.scheduler.CosineLRScheduler",anchor:"timm.scheduler.CosineLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/cosine_lr.py#L19"}}),I=new L({props:{name:"class timm.scheduler.MultiStepLRScheduler",anchor:"timm.scheduler.MultiStepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": typing.List[int]"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/multistep_lr.py#L10"}}),N=new L({props:{name:"class timm.scheduler.PlateauLRScheduler",anchor:"timm.scheduler.PlateauLRScheduler",parameters:[{name:"optimizer",val:""},{name:"decay_rate",val:" = 0.1"},{name:"patience_t",val:" = 10"},{name:"verbose",val:" = True"},{name:"threshold",val:" = 0.0001"},{name:"cooldown_t",val:" = 0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"lr_min",val:" = 0"},{name:"mode",val:" = 'max'"},{name:"noise_range_t",val:" = None"},{name:"noise_type",val:" = 'normal'"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = None"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/plateau_lr.py#L13"}}),F=new L({props:{name:"class timm.scheduler.PolyLRScheduler",anchor:"timm.scheduler.PolyLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"power",val:": float = 0.5"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/poly_lr.py#L19"}}),V=new L({props:{name:"class timm.scheduler.StepLRScheduler",anchor:"timm.scheduler.StepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": float"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/step_lr.py#L15"}}),A=new L({props:{name:"class timm.scheduler.TanhLRScheduler",anchor:"timm.scheduler.TanhLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lb",val:": float = -7.0"},{name:"ub",val:": float = 3.0"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/main/timm/scheduler/tanh_lr.py#L19"}}),j=new Ge({props:{source:"https://github.com/huggingface/pytorch-image-models/blob/main/hfdocs/source/reference/schedulers.mdx"}}),{c(){$=i("meta"),Z=n(),X=i("p"),ee=n(),c(T.$$.fragment),ae=n(),S=i("p"),S.innerHTML=ze,te=n(),c(z.$$.fragment),le=n(),c(R.$$.fragment),ne=n(),C=i("div"),c(P.$$.fragment),re=n(),M=i("div"),c(H.$$.fragment),ie=n(),c(E.$$.fragment),me=n(),o=i("div"),c(k.$$.fragment),$e=n(),U=i("p"),U.innerHTML=Re,be=n(),q=i("p"),q.innerHTML=Ce,ye=n(),G=i("p"),G.innerHTML=Pe,se=n(),D=i("div"),c(I.$$.fragment),oe=n(),b=i("div"),c(N.$$.fragment),we=n(),B=i("p"),B.textContent=Me,ce=n(),_=i("div"),c(F.$$.fragment),xe=n(),J=i("p"),J.textContent=He,Le=n(),K=i("p"),K.innerHTML=Ee,de=n(),O=i("div"),c(V.$$.fragment),pe=n(),y=i("div"),c(A.$$.fragment),Te=n(),Q=i("p"),Q.innerHTML=ke,ue=n(),c(j.$$.fragment),ve=n(),Y=i("p"),this.h()},l(e){const t=qe("svelte-u9bgzb",document.head);$=m(t,"META",{name:!0,content:!0}),t.forEach(a),Z=r(e),X=m(e,"P",{}),f(X).forEach(a),ee=r(e),d(T.$$.fragment,e),ae=r(e),S=m(e,"P",{"data-svelte-h":!0}),x(S)!=="svelte-k4ut34"&&(S.innerHTML=ze),te=r(e),d(z.$$.fragment,e),le=r(e),d(R.$$.fragment,e),ne=r(e),C=m(e,"DIV",{class:!0});var De=f(C);d(P.$$.fragment,De),De.forEach(a),re=r(e),M=m(e,"DIV",{class:!0});var Ie=f(M);d(H.$$.fragment,Ie),Ie.forEach(a),ie=r(e),d(E.$$.fragment,e),me=r(e),o=m(e,"DIV",{class:!0});var w=f(o);d(k.$$.fragment,w),$e=r(w),U=m(w,"P",{"data-svelte-h":!0}),x(U)!=="svelte-142rxjd"&&(U.innerHTML=Re),be=r(w),q=m(w,"P",{"data-svelte-h":!0}),x(q)!=="svelte-z0bxov"&&(q.innerHTML=Ce),ye=r(w),G=m(w,"P",{"data-svelte-h":!0}),x(G)!=="svelte-1wsck9y"&&(G.innerHTML=Pe),w.forEach(a),se=r(e),D=m(e,"DIV",{class:!0});var Ne=f(D);d(I.$$.fragment,Ne),Ne.forEach(a),oe=r(e),b=m(e,"DIV",{class:!0});var _e=f(b);d(N.$$.fragment,_e),we=r(_e),B=m(_e,"P",{"data-svelte-h":!0}),x(B)!=="svelte-1sewxb2"&&(B.textContent=Me),_e.forEach(a),ce=r(e),_=m(e,"DIV",{class:!0});var W=f(_);d(F.$$.fragment,W),xe=r(W),J=m(W,"P",{"data-svelte-h":!0}),x(J)!=="svelte-16f5sza"&&(J.textContent=He),Le=r(W),K=m(W,"P",{"data-svelte-h":!0}),x(K)!=="svelte-1wsck9y"&&(K.innerHTML=Ee),W.forEach(a),de=r(e),O=m(e,"DIV",{class:!0});var Fe=f(O);d(V.$$.fragment,Fe),Fe.forEach(a),pe=r(e),y=m(e,"DIV",{class:!0});var fe=f(y);d(A.$$.fragment,fe),Te=r(fe),Q=m(fe,"P",{"data-svelte-h":!0}),x(Q)!=="svelte-1rx2bx1"&&(Q.innerHTML=ke),fe.forEach(a),ue=r(e),d(j.$$.fragment,e),ve=r(e),Y=m(e,"P",{}),f(Y).forEach(a),this.h()},h(){g($,"name","hf:doc:metadata"),g($,"content",Je),g(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){s(document.head,$),l(e,Z,t),l(e,X,t),l(e,ee,t),p(T,e,t),l(e,ae,t),l(e,S,t),l(e,te,t),p(z,e,t),l(e,le,t),p(R,e,t),l(e,ne,t),l(e,C,t),p(P,C,null),l(e,re,t),l(e,M,t),p(H,M,null),l(e,ie,t),p(E,e,t),l(e,me,t),l(e,o,t),p(k,o,null),s(o,$e),s(o,U),s(o,be),s(o,q),s(o,ye),s(o,G),l(e,se,t),l(e,D,t),p(I,D,null),l(e,oe,t),l(e,b,t),p(N,b,null),s(b,we),s(b,B),l(e,ce,t),l(e,_,t),p(F,_,null),s(_,xe),s(_,J),s(_,Le),s(_,K),l(e,de,t),l(e,O,t),p(V,O,null),l(e,pe,t),l(e,y,t),p(A,y,null),s(y,Te),s(y,Q),l(e,ue,t),p(j,e,t),l(e,ve,t),l(e,Y,t),he=!0},p:Ve,i(e){he||(u(T.$$.fragment,e),u(z.$$.fragment,e),u(R.$$.fragment,e),u(P.$$.fragment,e),u(H.$$.fragment,e),u(E.$$.fragment,e),u(k.$$.fragment,e),u(I.$$.fragment,e),u(N.$$.fragment,e),u(F.$$.fragment,e),u(V.$$.fragment,e),u(A.$$.fragment,e),u(j.$$.fragment,e),he=!0)},o(e){v(T.$$.fragment,e),v(z.$$.fragment,e),v(R.$$.fragment,e),v(P.$$.fragment,e),v(H.$$.fragment,e),v(E.$$.fragment,e),v(k.$$.fragment,e),v(I.$$.fragment,e),v(N.$$.fragment,e),v(F.$$.fragment,e),v(V.$$.fragment,e),v(A.$$.fragment,e),v(j.$$.fragment,e),he=!1},d(e){e&&(a(Z),a(X),a(ee),a(ae),a(S),a(te),a(le),a(ne),a(C),a(re),a(M),a(ie),a(me),a(o),a(se),a(D),a(oe),a(b),a(ce),a(_),a(de),a(O),a(pe),a(y),a(ue),a(ve),a(Y)),a($),h(T,e),h(z,e),h(R,e),h(P),h(H),h(E,e),h(k),h(I),h(N),h(F),h(V),h(A),h(j,e)}}}const Je='{"title":"Learning Rate Schedulers","local":"learning-rate-schedulers","sections":[{"title":"Schedulers","local":"schedulers","sections":[{"title":"Factory functions","local":"timm.scheduler.create_scheduler","sections":[],"depth":3},{"title":"Scheduler Classes","local":"timm.scheduler.CosineLRScheduler","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ke(Se){return Ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ze extends je{constructor($){super(),Ue(this,$,Ke,Be,Oe,{})}}export{Ze as component};
